// Code generated by protoc-gen-go-grpc. DO NOT EDIT.
// versions:
// - protoc-gen-go-grpc v1.2.0
// - protoc             (unknown)
// source: services/simulations_service.proto

package services

import (
	context "context"
	domain "gitlab.com/ignitionrobotics/cloudsim/api/domain"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// SimulationsServiceClient is the client API for SimulationsService service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type SimulationsServiceClient interface {
	Get(ctx context.Context, in *domain.GroupID, opts ...grpc.CallOption) (*domain.Simulation, error)
}

type simulationsServiceClient struct {
	cc grpc.ClientConnInterface
}

func NewSimulationsServiceClient(cc grpc.ClientConnInterface) SimulationsServiceClient {
	return &simulationsServiceClient{cc}
}

func (c *simulationsServiceClient) Get(ctx context.Context, in *domain.GroupID, opts ...grpc.CallOption) (*domain.Simulation, error) {
	out := new(domain.Simulation)
	err := c.cc.Invoke(ctx, "/services.SimulationsService/Get", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// SimulationsServiceServer is the server API for SimulationsService service.
// All implementations must embed UnimplementedSimulationsServiceServer
// for forward compatibility
type SimulationsServiceServer interface {
	Get(context.Context, *domain.GroupID) (*domain.Simulation, error)
	mustEmbedUnimplementedSimulationsServiceServer()
}

// UnimplementedSimulationsServiceServer must be embedded to have forward compatible implementations.
type UnimplementedSimulationsServiceServer struct {
}

func (UnimplementedSimulationsServiceServer) Get(context.Context, *domain.GroupID) (*domain.Simulation, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Get not implemented")
}
func (UnimplementedSimulationsServiceServer) mustEmbedUnimplementedSimulationsServiceServer() {}

// UnsafeSimulationsServiceServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to SimulationsServiceServer will
// result in compilation errors.
type UnsafeSimulationsServiceServer interface {
	mustEmbedUnimplementedSimulationsServiceServer()
}

func RegisterSimulationsServiceServer(s grpc.ServiceRegistrar, srv SimulationsServiceServer) {
	s.RegisterService(&SimulationsService_ServiceDesc, srv)
}

func _SimulationsService_Get_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(domain.GroupID)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(SimulationsServiceServer).Get(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/services.SimulationsService/Get",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(SimulationsServiceServer).Get(ctx, req.(*domain.GroupID))
	}
	return interceptor(ctx, in, info, handler)
}

// SimulationsService_ServiceDesc is the grpc.ServiceDesc for SimulationsService service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var SimulationsService_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "services.SimulationsService",
	HandlerType: (*SimulationsServiceServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "Get",
			Handler:    _SimulationsService_Get_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "services/simulations_service.proto",
}
